/* Copyright (c) 2006-2015 Polybus Systems Corp., Westford, MA, USA */

/* All rights reserved. */

/* Redistribution and use in source and binary forms, with or without modification, */
/* are permitted provided that the following conditions are met: */

/* * Redistributions of source code must retain the above copyright notice, this */
/* list of conditions and the following disclaimer. */
/* * Redistributions in binary form must reproduce the above copyright notice, */
/* this list of conditions and the following disclaimer in the documentation */
/* and/or other materials provided with the distribution. */
/* * Neither the name of the Polybus Systems Corp nor the names of its contributors */
/* may be used to endorse or promote products derived from this software */
/* without specific prior written permission. */

/* THIS SOFTWARE IS PROVIDED BY POLYBUS AND CONTRIBUTORS ''AS IS'' AND ANY */
/* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED */
/* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE */
/* DISCLAIMED. IN NO EVENT SHALL POLYBUS OR CONTRIBUTORS BE LIABLE FOR ANY */
/* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES */
/* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; */
/* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON */
/* ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT */
/* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS */
/* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */

SInt32 limitToWidth(UInt64 limit);
long addrEqDataTest(SInt64 *base,SInt64 limit,SInt32 num,SInt32 test_num,result rslt[NUM_ADDREQ],SInt32 vnum,SInt32 verbose);
long bankTest(SInt64 *base,SInt64 limit,SInt32 num,SInt32 test_num,result rslt[NUM_BANK],SInt32 vnum,SInt32 verbose);
long fixedTest(SInt64 *base,SInt64 limit,SInt32 num,SInt32 test_num,result *rslt,SInt32 vnum,SInt32 verbose);
long lfsrTest(SInt64 *base,SInt64 limit,SInt32 num,SInt32 test_num,result rslt[NUM_LFSR],SInt32 vnum,SInt32 verbose,UInt64 *seed, Boolean testRefresh);
long memBandwidth(SInt64 *base,SInt64 limit,SInt32 num,SInt32 num_threads,result rslt[2][MAX_SIZES],SInt32 vnum);
long revAddressTest(SInt64 *base,SInt64 limit,SInt32 num,SInt32 test_num,result rslt[NUM_ADDREQ],SInt32 vnum,SInt32 verbose);
long revAddressTopDownTest(SInt64 *base,SInt64 limit,SInt32 num,SInt32 test_num,result rslt[NUM_ADDREQ],SInt32 vnum,SInt32 verbose);
long swapTest(SInt64 *base,SInt64 limit,SInt32 num,result *rslt,SInt32 vnum,SInt32 verbose);
long walkTest(SInt64 *base,SInt64 limit,SInt32 num,SInt32 test_num,result rslt[NUM_ADDREQ],SInt32 vnum,SInt32 verbose);
void getBitRev(UInt64 array[1024],UInt64 start,SInt32 width);
void getLFSR(UInt64 data[16]);




